---
title: Answering a Call
slug: Web/API/WebRTC_API/build_a_phone_with_peerjs/connect_peers/answer_a_call
---
<p>{{WebRTCSidebar}}</p>

<p>{{PreviousMenuNext("Web/API/WebRTC_API/build_a_phone_with_peerjs/connect_peers/creating_a_call", "Web/API/WebRTC_API/build_a_phone_with_peerjs/connect_peers/end_a_call")}}</p>

<p id="48e2">The peerJS framework makes the <code>.on('call')</code> event available to use so let’s use it here.</p>

<pre class="brush: js notranslate"><strong><em>peer</em></strong>.on('call', function(call) {
    const answerCall = confirm("Do you want to answer?")
});</pre>

<p id="4063"><strong>A</strong>. <code>const answerCall = confirm("Do you want to answer")</code>: First, let’s prompt the user to answer with a confirm prompt. This will show a window on the screen (as shown in the image) which the user can select “ok” or “cancel”, which maps to a boolean value which is returned. When you press "Call" in your browser, the following prompt should appear:</p>

<p><img alt='A browser prompt that asks "Do you want to answer?" with two options: "Cancel" and "Ok"' src="https://miro.medium.com/max/1000/1*Hfnup1P6aEdvFbaRRo6ajQ.png" style="height: 692px; width: 1000px;"></p>

<div class="notecard warning">
<p>Since we’re using a <code>confirm</code> prompt to ask the user if they want to answer the call, it’s important that the browser and tab that’s being called be “active” that means the window shouldn’t be minimised and the tab should be on screen and have the mouse’s focus somewhere in the tab. Ideally, you’d create your own modal in HTML which wouldn’t have these limitations.</p>
</div>

<p>Let's flesh out this event listener:</p>

<pre class="brush: js notranslate"><strong><em>peer</em></strong>.on('call', function(call) {
   const answerCall = confirm("Do you want to answer?")

   if(answerCall){
      call.answer(<strong><em>window</em></strong>.localStream) // <strong>A</strong>
      showConnectedContent(); // <strong>B</strong>
      call.on('stream', function(stream) { // <strong>C</strong>
<strong><em>         window</em></strong>.remoteAudio.srcObject = stream;
<strong><em>         window</em></strong>.remoteAudio.autoplay = true;
<strong><em>         window</em></strong>.peerStream = stream;
      });
   } else {
<strong><em>      console</em></strong>.log("call denied"); // <strong>D</strong>
   }
});</pre>

<p id="5350"><strong>A</strong>. <code>call.answer(window.localStream)</code>: if the <code>answerCall</code> is true, then you want to call peerJS’s <code>answer</code> function on the call to create an answer, passing it the local stream.</p>

<p id="d9a2"><strong>B</strong>. <code>showCallContent</code>: similarly to what you did in the call button event listener, you want to ensure the person being called sees the correct HTML content.</p>

<p id="db5f"><strong>C</strong>. Everything in the <code>call.on('stream', function(){...}</code> block is exactly the same as it is in call button’s event listener. The reason you need to add it here too is so that the browser is also updated for the person answering the call.</p>

<p id="8494"><strong>D</strong>. If the person denies the call, we’re just going to log a message to the console.</p>

<p id="8eee">The code you have now is enough for you to create a call and answer it. Refresh your browsers and test it out. You’ll want to make sure that both browsers have the console open or else you won’t get the prompt to answer the call. Click call, submit the peer ID for the other browser and then answer the call. The final page should look like this:</p>

<figure>
<p><img alt="Two screens side by side both have a cream background with the words 'phone a friend' in bold, dark green font as the heading. 'You're connected.' is immediately below that and 'please use headphones!' and 'You're automatically muted, please unmute yourself!' below that. Following on, a big dark red button with 'Hang up' written in the same cream colour of the background." src="https://miro.medium.com/max/1400/1*KBtS6k_EfhTUjWuunDg2cQ.png" style="height: 805px; width: 1400px;"></p>
</figure>

<p>{{PreviousMenuNext("Web/API/WebRTC_API/build_a_phone_with_peerjs/connect_peers/creating_a_call", "Web/API/WebRTC_API/build_a_phone_with_peerjs/connect_peers/end_a_call")}}</p>
